/*
 * Template for getting started with an API!
 */
(function() {
  "use strict";

  // 0. (get API_KEY if API key needed)
  // 1. What is the URL?

  window.addEventListener("load", initialize);

  /**
   * 2. Setup initial page behavior/button handlers
   */
  function initialize() {
    // TODO: what do we want to trigger a fetch call?
    // - when fetch button is clicked:
    //   * Call our fetchData function to send request to API
    //   * Somehow let our user know the request is loading
    //   * Disable button to avoid multiple requests (re-enable when done)
  }

  /**
   *  3. TODO (finish): Make a fetch call to our API
   */
  function fetchData(){
  }

  /*
   * 4A. TODO (implement): Response handling method v1: Print data to console to make sure request/response
   * was successful
   */
  function processResponseV1() {
  }

  /*
   * 5. Handle any errors so a user knows whether something went wrong
   */
  function handleError(error) {
  }


  /**
   * 4B. TODO (implement): Response handling method v1: Instead of using v1 to just log data, use data to create DOM elements, etc.
   * on our page!
   * @param responseData - the JSON object that is was returned from the server
   */
  function processResponseV2(responseData){
    // clear response box
    $("response").innerHTML = "";

    //See sample json response at top of file
    let title = document.createElement("h2");
    title.innerText = ""; // TODO: What is a good title given the data?

    // TODO: Do we have any images we can create from the data?
    /*
      let image = document.createElement("img");
      image.src = "";
      image.alt = "";
    */

    // TODO: Do we have any summary we can create from the data?
    let summary = document.createElement("p");
    summary.innerText = "";

    //$("response").appendChild(title);
    //$("response").appendChild(image);
    //$("response").appendChild(explanation);

    //re-enable button
    $("fetch-btn").disabled = false;
  }





  /* ------------------------------ Helper Functions  ------------------------------ */

  /**
   * Returns the element that has the ID attribute with the specified value.
   * @param {string} id - element ID
   * @returns {object} DOM object associated with id.
   */
  function $(id) {
    return document.getElementById(id);
  }

  /**
   * Returns the first element that matches the given CSS selector.
   * @param {string} query - CSS query selector.
   * @returns {object} The first DOM object matching the query.
   */
  function qs(query) {
    return document.querySelector(query);
  }

  /**
   * Returns the array of elements that match the given CSS selector.
   * @param {string} query - CSS query selector
   * @returns {object[]} array of DOM objects matching the query.
   */
  function qsa(query) {
    return document.querySelectorAll(query);
  }

  /*
   * Helper function to return the response's result text if successful, otherwise
   * returns the rejected Promise result with an error status and corresponding text
   * @param {object} response - response to check for success/error
   * @return {object} - valid result text if response was successful, otherwise rejected
   *                    Promise result
   */
  function checkStatus(response) { 
    if (response.status >= 200 && response.status < 300 || response.status == 0) {  
      return response.text();
    } else {  
      return Promise.reject(new Error(response.status + ": " + response.statusText)); 
    }
  }
})();


